package net.t2code.alias.Spigot.system;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.cmdManagement.AliasCmdExecuter;
import net.t2code.alias.Spigot.config.config.CreateConfig;
import net.t2code.alias.Spigot.config.config.CreateExampleAliasConfig;
import net.t2code.alias.Spigot.config.config.SelectAlias;
import net.t2code.alias.Spigot.config.config.SelectConfig;
import net.t2code.alias.Spigot.config.languages.LanguagesCreate;
import net.t2code.alias.Spigot.config.languages.SelectMessages;
import net.t2code.alias.Util;
import net.t2code.lib.Spigot.Lib.messages.T2CodeTemplate;
import net.t2code.lib.Spigot.Lib.update.UpdateAPI;
import org.bukkit.Bukkit;
import org.bukkit.plugin.Plugin;


import java.io.File;
import java.util.List;

public class Load {
    static Plugin plugin = Main.plugin;
    public static void onLoad(String prefix, List autor, String version, String spigot, int spigotID, String discord, int bstatsID) {
        Long long_ = T2CodeTemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        Main.plugin.getCommand("t2code-alias").setExecutor(new AliasCmdExecuter());
        loadReload();
        UpdateAPI.onUpdateCheck(plugin, prefix, spigot, spigotID, discord);
        Bukkit.getServer().getPluginManager().registerEvents(new JoinEvent(), plugin);

        T2CodeTemplate.onLoadFooter(prefix, long_,version);
        Metrics.Bstats(plugin, bstatsID);
    }

    public static void loadReload() {
        if (!new File(Main.getPath(), "config.yml").exists()) {
            try {
                CreateExampleAliasConfig.configCreate();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        try {
            plugin.saveResource("Alias/X_aliasDeclaration_X.yml",true);
        } catch (Exception e) {
            e.printStackTrace();
        }
        CreateConfig.configCreate();
        LanguagesCreate.langCreate();
        SelectConfig.onSelect();
        SelectMessages.onSelect(Util.getPrefix());
        SelectAlias.onSelect();

        if (SelectConfig.Bungee) {
            Main.plugin.getServer().getMessenger().registerOutgoingPluginChannel(Main.plugin, "BungeeCord");
            Bukkit.getMessenger().registerOutgoingPluginChannel(Main.plugin, "t2codealias:bungee");
        }
        AliasRegisterPermissions.onPermRegister();
    }

}
